2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [-k|--keep-index] [-q|--quiet] [<message>]]
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
24 if git config --get-colorbool color.interactive; then
25 help_color="$(git config --get-color color.interactive.help 'red bold')"
26 reset_color="$(git config --get-color '' reset)"
33 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
34 git diff-files --quiet --ignore-submodules
40 die "git stash clear with parameters is unimplemented"
42 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
44 git update-ref -d $ref_stash $current
51 git update-index -q --refresh
57 # state of the base commit
58 if b_commit=$(git rev-parse --verify HEAD)
60 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
62 die "You do not have the initial commit yet"
65 if branch=$(git symbolic-ref -q HEAD)
67 branch=${branch#refs/heads/}
71 msg=$(printf '%s: %s' "$branch" "$head")
74 i_tree=$(git write-tree) &&
75 i_commit=$(printf 'index on %s\n' "$msg" |
76 git commit-tree $i_tree -p $b_commit) ||
77 die "Cannot save the current index state"
79 if test -z "$patch_mode"
82 # state of the working tree
85 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
86 GIT_INDEX_FILE="$TMP-index" &&
87 export GIT_INDEX_FILE &&
88 git read-tree -m $i_tree &&
93 die "Cannot save the current worktree state"
98 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
100 # find out what the user wants
101 GIT_INDEX_FILE="$TMP-index" \
102 git add--interactive --patch=stash -- &&
104 # state of the working tree
105 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106 die "Cannot save the current worktree state"
108 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109 test -s "$TMP-patch" ||
110 die "No changes selected"
112 rm -f "$TMP-index" ||
113 die "Cannot remove temporary index (can't happen)"
118 if test -z "$stash_msg"
120 stash_msg=$(printf 'WIP on %s' "$msg")
122 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
124 w_commit=$(printf '%s\n' "$stash_msg" |
125 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126 die "Cannot record working tree state"
153 echo "error: unknown option for 'stash save': $1"
165 git update-index -q --refresh
168 say 'No local changes to save'
171 test -f "$GIT_DIR/logs/$ref_stash" ||
172 clear_stash || die "Cannot initialize stash"
174 create_stash "$stash_msg"
176 # Make sure the reflog for stash is kept.
177 : >>"$GIT_DIR/logs/$ref_stash"
179 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
180 die "Cannot save the current status"
181 say Saved working directory and index state "$stash_msg"
183 if test -z "$patch_mode"
185 git reset --hard ${GIT_QUIET:+-q}
187 if test -n "$keep_index" && test -n $i_tree
189 git read-tree --reset -u $i_tree
192 git apply -R < "$TMP-patch" ||
193 die "Cannot remove worktree changes"
195 if test -z "$keep_index"
203 git rev-parse --verify $ref_stash >/dev/null 2>&1
207 have_stash || return 0
208 git log --format="%gd: %gs" -g "$@" $ref_stash --
212 flags=$(git rev-parse --no-revs --flags "$@")
218 w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
219 b_commit=$(git rev-parse --verify "$w_commit^") &&
220 git diff $flags $b_commit $w_commit
244 have_stash || die 'Nothing to apply'
247 # stash records the work tree, and is a merge between the
248 # base commit (first parent) and the index tree (second parent).
249 s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
250 w_tree=$(git rev-parse --quiet --verify "$s:") &&
251 b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
252 i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
253 die "$*: no valid stashed state found"
255 git update-index -q --refresh &&
256 git diff-files --quiet --ignore-submodules ||
257 die 'Cannot apply to a dirty working tree, please stage your changes'
259 # current index state
260 c_tree=$(git write-tree) ||
261 die 'Cannot apply a stash in the middle of a merge'
263 unstashed_index_tree=
264 if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
265 test "$c_tree" != "$i_tree"
267 git diff-tree --binary $s^2^..$s^2 | git apply --cached
269 die 'Conflicts in index. Try without --index.'
270 unstashed_index_tree=$(git write-tree) ||
271 die 'Could not save index tree'
276 GITHEAD_$w_tree='Stashed changes' &&
277 GITHEAD_$c_tree='Updated upstream' &&
278 GITHEAD_$b_tree='Version stash was based on' &&
279 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
282 if test -n "$GIT_QUIET"
284 export GIT_MERGE_VERBOSITY=0
286 if git merge-recursive $b_tree -- $c_tree $w_tree
289 if test -n "$unstashed_index_tree"
291 git read-tree "$unstashed_index_tree"
294 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
295 git read-tree --reset $c_tree &&
296 git update-index --add --stdin <"$a" ||
297 die "Cannot unstage modified files"
301 if test -n "$GIT_QUIET"
303 squelch='>/dev/null 2>&1'
305 eval "git status $squelch" || :
307 # Merge conflict; keep the exit status from merge-recursive
309 if test -n "$unstash_index"
311 echo >&2 'Index was not unstashed.'
318 have_stash || die 'No stash entries to drop'
335 set x "$ref_stash@{0}"
338 # Verify supplied argument looks like a stash entry
339 s=$(git rev-parse --verify "$@") &&
340 git rev-parse --verify "$s:" > /dev/null 2>&1 &&
341 git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
342 git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
343 die "$*: not a valid stashed state"
345 git reflog delete --updateref --rewrite "$@" &&
346 say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
348 # clear_stash if we just dropped the last stash entry
349 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
353 have_stash || die 'Nothing to apply'
355 test -n "$1" || die 'No branch name specified'
360 set x "$ref_stash@{0}"
364 git checkout -b $branch $stash^ &&
365 apply_stash --index $stash &&
369 # The default command is "save" if nothing but options are given
375 *) seen_non_option=t; break ;;
379 test -n "$seen_non_option" || set "save" "$@"
404 if test $# -gt 0 && test "$1" = create
408 create_stash "$*" && echo "$w_commit"
418 test -z "$unstash_index" || shift
430 say '(To restore them type "git stash apply")'